FROM maven:3.6.1-jdk-11-slim as maven
WORKDIR /armeria
COPY src src
COPY pom.xml pom.xml
RUN mvn package -q

FROM openjdk:11.0.3-jdk-slim
WORKDIR /armeria
COPY --from=maven /armeria/target/hello-1.0-SNAPSHOT.jar app.jar
CMD ["java", "-server", "-XX:+UseNUMA", "-XX:+UseParallelGC", "-jar", "app.jar"]
